
from paraview.simple import *
from paraview import coprocessing


#--------------------------------------------------------------
# Code generated from cpstate.py to create the CoProcessor.
# paraview version 5.5.2-1-g0aca7619ff

#--------------------------------------------------------------
# Global screenshot output options
imageFileNamePadding=0
rescale_lookuptable=False


# ----------------------- CoProcessor definition -----------------------

def CreateCoProcessor():
  def _CreatePipeline(coprocessor, datadescription):
    class Pipeline:
      # state file generated using paraview version 5.5.2-1-g0aca7619ff

      # ----------------------------------------------------------------
      # setup the data processing pipelines
      # ----------------------------------------------------------------

      # trace generated using paraview version 5.5.2-1-g0aca7619ff

      #### disable automatic camera reset on 'Show'
      paraview.simple._DisableFirstRenderCameraReset()

      # create a new 'PVD Reader'
      # create a producer from a simulation input
      particles = coprocessor.CreateProducer(datadescription, 'particles')

      # create a new 'SPH Volume Interpolator'
      sPHVolumeInterpolator1 = SPHVolumeInterpolator(Input=particles,
          Source='Bounded Volume')
      sPHVolumeInterpolator1.DensityArray = 'collision'
      sPHVolumeInterpolator1.MassArray = 'None'
      sPHVolumeInterpolator1.CutoffArray = 'None'
      sPHVolumeInterpolator1.Kernel = 'SPHQuinticKernel'
      sPHVolumeInterpolator1.Locator = 'Static Point Locator'

      # init the 'SPHQuinticKernel' selected for 'Kernel'
      sPHVolumeInterpolator1.Kernel.SpatialStep = 0.1

      # init the 'Bounded Volume' selected for 'Source'
      sPHVolumeInterpolator1.Source.Origin = [-0.9998392721502525, -0.9999279446295348, -0.9999997701515202]
      sPHVolumeInterpolator1.Source.Scale = [2.0, 2.0, 2.0]
      sPHVolumeInterpolator1.Source.Resolution = [30, 30, 10]

      # create a new 'Parallel PolyData Writer'
      parallelPolyDataWriter1 = servermanager.writers.XMLPPolyDataWriter(Input=particles)

      # create a new 'Parallel ImageData Writer'
      parallelImageDataWriter1 = servermanager.writers.XMLPImageDataWriter(Input=sPHVolumeInterpolator1)

     # register the writer with coprocessor
      # and provide it with information such as the filename to use,
      # how frequently to write the data, etc.
      coprocessor.RegisterWriter(parallelPolyDataWriter1, filename='particles_%t.pvtp', freq=50, paddingamount=0)
      coprocessor.RegisterWriter(parallelImageDataWriter1, filename='density_%t.pvti', freq=10, paddingamount=2)

      # ----------------------------------------------------------------
      # finally, restore active source
      SetActiveSource(sPHVolumeInterpolator1)
      # ----------------------------------------------------------------
    return Pipeline()

  class CoProcessor(coprocessing.CoProcessor):
    def CreatePipeline(self, datadescription):
      self.Pipeline = _CreatePipeline(self, datadescription)

  coprocessor = CoProcessor()
  # these are the frequencies at which the coprocessor updates.
  freqs = {'particles': [50]}
  coprocessor.SetUpdateFrequencies(freqs)
  return coprocessor


#--------------------------------------------------------------
# Global variable that will hold the pipeline for each timestep
# Creating the CoProcessor object, doesn't actually create the ParaView pipeline.
# It will be automatically setup when coprocessor.UpdateProducers() is called the
# first time.
coprocessor = CreateCoProcessor()

#--------------------------------------------------------------
# Enable Live-Visualizaton with ParaView and the update frequency
coprocessor.EnableLiveVisualization(True, 1)

# ---------------------- Data Selection method ----------------------

def RequestDataDescription(datadescription):
    "Callback to populate the request for current timestep"
    global coprocessor
    if datadescription.GetForceOutput() == True:
        # We are just going to request all fields and meshes from the simulation
        # code/adaptor.
        for i in range(datadescription.GetNumberOfInputDescriptions()):
            datadescription.GetInputDescription(i).AllFieldsOn()
            datadescription.GetInputDescription(i).GenerateMeshOn()
        return

    # setup requests for all inputs based on the requirements of the
    # pipeline.
    coprocessor.LoadRequestedData(datadescription)

# ------------------------ Processing method ------------------------

def DoCoProcessing(datadescription):
    "Callback to do co-processing for current timestep"
    global coprocessor

    # Update the coprocessor by providing it the newly generated simulation data.
    # If the pipeline hasn't been setup yet, this will setup the pipeline.
    coprocessor.UpdateProducers(datadescription)

    # Write output data, if appropriate.
    coprocessor.WriteData(datadescription);

    # Write image capture (Last arg: rescale lookup table), if appropriate.
    coprocessor.WriteImages(datadescription, rescale_lookuptable=rescale_lookuptable,
        image_quality=0, padding_amount=imageFileNamePadding)

    # Live Visualization, if enabled.
    coprocessor.DoLiveVisualization(datadescription, "localhost", 22222)
